
;	@com.wudsn.ide.asm.mainsourcefile=GSWBM.asm

	org $3800		;Demo

	opt f+			;Improve packer performance

	.proc demo_grey
	jmp main

;===============================================================

	.proc init

	mwa #0 cnt
	rts

	.endp			;End of init

;===============================================================
	.proc vbi
	.var index .word

	inw cnt
	mwa cnt index
	lda index
	lsr index+1
	ror
	lsr index+1
	ror
	lsr index+1
	ror
	lsr index+1
	ror
	tay
	lda init,y
	sta $d200
	sta $d214
	adc #1
	sta $d202
	sta $d212
	lda cnt
	asl
	and #15
	eor #15
	ora #$a0
	sta $d201
	sta $d203
	sta $d213
	sta $d211
;	lda cnt
;	lsr
;	lsr
;	lsr
;	eor cnt+1
;	and #7
;	tax
;	eor cnt
;	and $d20a
;	sta $d200,x
;	sta $d211,x
;	sta $d221,x
;	sta $d230,x
	rts
	.endp			;End of vbi

;===============================================================

	.proc main

	sei			;stop interrups
	lda #0
	sta $d400
	sta nmien
	mva #>pmg pmbase	;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles

////////////////////
// RASTER PROGRAM //
////////////////////

	jsr init
wait_sync
	lda $d40b
	bne wait_sync

LOOP	lda #$ff
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3
	sta sizem
	sta grafm
	mva #$20 hposm0
	mva #$28 hposm1
	mva #$d0 hposm2
	mva #$d8 hposm3

	mva #$02 pmcntl
	lda #$14
	sta gtictl

	lda vcount		;synchronization for the first screen line
	cmp #$02
	bne LOOP

	mva #%00111110 dmactl	;set new screen width
	mva #<ant dlptr
	mva #>ant dlptr+1

	icl "RC/Grey/output.png.rp.ini"

;--- wait 18 cycles
	jsr _rts
	inc byt3

;--- set global offset (23 cycles)
	jsr _rts
	cmp byt3\ pha:pla

;--- empty line
	jsr wait54cycle
	inc byt2

  	icl "RC/Grey/output.png.rp"

raster_program_end

	lda #$02
	sta $d40a
	sta $d01a
	sta $d019
	sta $d018

//--------------------
//	EXIT
//--------------------

	lda cnt+1
	cmp #4
	beq stop

	lda trig0		; FIRE #0
	and trig1		; FIRE #1
	and consol		; START
	beq stop

	lda skctl		; ANY KEY
	and #$04
	bne skp

stop	mva #$00 pmcntl		;PMG disabled
	tax
clear	sta hposp0,x
	sta $d200,x
	inx
	bne clear
	sta 559
	sta $d400
	lda #3
	sta $d20f
	sta $d21f

	mva #$f8 $d218
	sta $d208
	mva #$d3 $d214
	sta $d200
	mva #$af $d215
	sta $d201
	mva #$af $d216
	sta $d202
	mva #$0a $d217
	sta $d203

	mva #$40 $d40e
	cli
	
release_key
	lda skctl		; ANY KEY
	and #$04
	beq release_key

	rts
skp

//--------------------
	jsr vbi
	jmp LOOP

;---

wait54cycle
	:2 inc byt2
wait44cycle
	inc byt3
	nop
wait36cycle
	inc byt3
	jsr _rts
wait18cycle
	inc byt3
_rts	rts

byt3	= $ffff


;---

.MACRO	ANTIC_PROGRAM
	:+8 dta $4e,a(:1+$0000+#*40)
	:+8 dta $4e,a(:1+$0140+#*40)
	:+8 dta $4e,a(:1+$0280+#*40)
	:+8 dta $4e,a(:1+$03C0+#*40)
	:+8 dta $4e,a(:1+$0500+#*40)
	:+8 dta $4e,a(:1+$0640+#*40)
	:+8 dta $4e,a(:1+$0780+#*40)
	:+8 dta $4e,a(:1+$08C0+#*40)
	:+8 dta $4e,a(:1+$0A00+#*40)
	:+8 dta $4e,a(:1+$0B40+#*40)
	:+8 dta $4e,a(:1+$0C80+#*40)
	:+8 dta $4e,a(:1+$0DC0+#*40)
	:+8 dta $4e,a(:1+$0F00+#*40)
	:+8 dta $4e,a(:1+$1040+#*40)
	:+8 dta $4e,a(:1+$1180+#*40)
	:+8 dta $4e,a(:1+$12C0+#*40)
	:+8 dta $4e,a(:1+$1400+#*40)
	:+8 dta $4e,a(:1+$1540+#*40)
	:+8 dta $4e,a(:1+$1680+#*40)
	:+8 dta $4e,a(:1+$17C0+#*40)
	:+8 dta $4e,a(:1+$1900+#*40)
	:+8 dta $4e,a(:1+$1A40+#*40)
	:+8 dta $4e,a(:1+$1B80+#*40)
	:+8 dta $4e,a(:1+$1CC0+#*40)
	:+8 dta $4e,a(:1+$1E00+#*40)
.ENDM

	.endp				;End of main
;===============================================================

	.print *
	org $5c00		;Player missble graphics (players only)
pmg = $5800
	.local pmg2
	icl "RC/Grey/output.png.pmg"	;With missages commented out manually
	.endl
	m_info pmg2

	org $6010		;Rasterprogram Mode: GED- (bitmap mode)

	.local scr
	ins "RC/Grey/output.png.mic"
	.endl
	m_info scr

	org $b800		;Display list
	.local ant
	main.ANTIC_PROGRAM scr,ant
	dta $41,a(ant)
	.endl

	m_info ant

	.endp			;End of demo
